#include "flwr.h"
#include <iostream>

varExprns::varExprns(string var, string exp){

	variable = var;
	expression = exp;
	next = NULL;

};


varExprns::~varExprns(){

	if (next != NULL){
		delete next;
		next = NULL;
	}

};

string varExprns::getExpr(){

	return expression;

};

string varExprns::getVar(){

	return variable;

};

varExprns * varExprns::getNextVarExprn(){

	return next;

};

void varExprns::addVarExprn(string var, string exprn){

	if(next != NULL){
		next->addVarExprn(var, exprn);
	}else{
		next = new varExprns(var, exprn);
	}

};


///////////////////////////////////////////////
///////////////////////////////////////////////


forLets::forLets(bool newIsFor){

	isFor = newIsFor;
	firstVarExprn = NULL;
	next = NULL;

};


forLets::~forLets(){

	if(firstVarExprn != NULL){
		delete firstVarExprn;
		firstVarExprn = NULL;
	}

	if (next != NULL){
		delete next;
		next = NULL;
	}

};

varExprns* forLets::getFirstVarExprn(){

	return firstVarExprn;

};

forLets * forLets::getNextForLet(){

	return next;

};

void forLets::addVarExprn(string var, string exprn){

	if(firstVarExprn != NULL){
		firstVarExprn->addVarExprn(var, exprn);
	}else{
		firstVarExprn = new varExprns(var, exprn);
	}

};

void forLets::addForLet(forLets * newForLet){

	if(next != NULL){
		next->addForLet(newForLet);
	}else{
		next = newForLet;
	}

};


///////////////////////////////////////////////
///////////////////////////////////////////////


flwr::flwr(){

	firstForLet = NULL;
	returnExpr = "";
	whereExpr = "";
	numFors = 0;
	numLets = 0;
	numXPaths = 0;

};

flwr::~flwr(){

	if(firstForLet != NULL){
		delete firstForLet;
		firstForLet = NULL;
	}

};

void flwr::addForLet(forLets* newForLet){

	if(firstForLet != NULL){
		firstForLet->addForLet(newForLet);
	}else{
		firstForLet = newForLet;
	}

};

forLets * flwr::getFirstForLet(){

	return firstForLet;

};

string flwr::getWhere(){

	return whereExpr;

};

string flwr::getReturn(){

	return returnExpr;

};

void flwr::setWhere(string newWhere){

	whereExpr = newWhere;

};

void flwr::setReturn(string newReturn){

	returnExpr = newReturn;

};

string ** flwr::getReturnXPaths(){

	return getXPaths(returnExpr);

};

string ** flwr::getWhereXPaths(){

	return getXPaths(whereExpr);

};

string ** flwr::getXPaths(string expr){

	int exprLength = expr.length();
	int exprPlace = 0;
	string trash = "";

	//string var = "";
	//string varVal = "";
	string **xPath = new string*[50];
	
	int xPathCount = 0;

	while(exprPlace < exprLength){
		string var = "";
		string varVal = "";
		xPath[xPathCount] = new string;
		while(exprPlace < exprLength && expr[exprPlace] != '$'){
			trash = trash + expr[exprPlace];
			exprPlace++;
		}
		
		if(exprPlace < exprLength){
			var = expr[exprPlace];
			exprPlace++;
		}

		while(exprPlace < exprLength && (
			  (expr[exprPlace] >= 'A' && expr[exprPlace] <= 'Z') ||
			  (expr[exprPlace] >= 'a' && expr[exprPlace] <= 'z') ||
			  (expr[exprPlace] >= '0' && expr[exprPlace] <= '9') )){ 

			// || OTHER CASES??

			var = var + expr[exprPlace];
			exprPlace++;
		}
		if(var == ""){
			continue;
		}
		varVal = searchForVariableDef(var);
		while (replaceVar(varVal)){
		}
		// ALSO MUST MAKE SURE THERE AREN'T VARIABLES 
		// IN THE VARIABLE DEFINITIONS
		// WE NEED TO ADD CODE TO KEEP EXPANDING
		if(varVal == ""){
			// ERROR!!
			cout << "Couldn't find def of variable: " << var << endl;
		}

		
		*(xPath[xPathCount]) = varVal;
		int braceCount = 0;
		int bracketCount = 0;
		int parenthCount = 0;
		int foundText = 0;
		while(exprPlace < exprLength && 
			!(bracketCount == 0 && parenthCount == 0
			 && (expr[exprPlace] == ' '  || 
				 expr[exprPlace] == '\n' || 
				 expr[exprPlace] == '>'  ||	
				 expr[exprPlace] == '<'  ||	
				 expr[exprPlace] == '='  ||	
				 expr[exprPlace] == ')'  ||	
				 expr[exprPlace] == '}'  || 
				 expr[exprPlace] == ']'  ||
				 expr[exprPlace] == ':'  ||
				 expr[exprPlace] == '"'  ||	
				 expr[exprPlace] == '\'' ||	
				 expr[exprPlace] == '*'  ||	
				 expr[exprPlace] == '+'  ||	
				 expr[exprPlace] == '-'  ||	
				 expr[exprPlace] == '\\' ||	
				 expr[exprPlace] == '!'  ||	
				 expr[exprPlace] == ';'  ||
				 foundText == 6))
			){
			bool foundBool = false; 

			switch(expr[exprPlace]){
			case 't':
				if(foundText == 0 || foundText == 3){
					foundBool = true; 
				}
				break;
			case 'e':
				if(foundText == 1){
					foundBool = true; 
				}
				break;
			case 'x':
				if(foundText == 2){
					foundBool = true; 
				}
				break;
			case '[':
				bracketCount++;
				break;
			case ']':
				bracketCount--;
				break;
			case '(':
				parenthCount++;
				if(foundText == 4){
					foundBool = true; 
				}
				break;
			case ')':
				parenthCount--;
				if(foundText == 5){
					foundBool = true; 
				}
				break;
			case '{':
				braceCount++;
				break;
			case '}':
				braceCount--;
				break;
			case '$':
				while (exprPlace < exprLength && (
					  (expr[exprPlace] >= 'A' && expr[exprPlace] <= 'Z') ||
					  (expr[exprPlace] >= 'a' && expr[exprPlace] <= 'z') ||
					  (expr[exprPlace] >= '0' && expr[exprPlace] <= '9') )){ 
						// || OTHER CASES??
					var = var + expr[exprPlace];
					exprPlace++;
				}
				varVal = searchForVariableDef(var);
				// ALSO MUST MAKE SURE THERE AREN'T VARIABLES 
				// IN THE VARIABLE DEFINITIONS
				// WE NEED TO KEEP ADD CODE TO KEEP EXPANDING
				if(varVal == ""){
					// ERROR!!
					cout << "Couldn't find def of variable: " << var << endl;
				}
				*(xPath[xPathCount]) = *(xPath[xPathCount]) + varVal;
				break;
			default:
				break;
			}

			if(foundBool){
				foundText++;
			}else{
				foundText = 0;
			}

			*(xPath[xPathCount]) = *(xPath[xPathCount]) + expr[exprPlace];
			exprPlace++;
		}

		xPathCount++;
	}

	while(xPathCount < 50){
		xPath[xPathCount] = NULL;
		xPathCount++;
	}

	return xPath;

};

string flwr::searchForVariableDef(string var){

	forLets* curForLet = firstForLet;
	varExprns* curVarExprn;
	
	while(curForLet != NULL){
		curVarExprn = curForLet->getFirstVarExprn();
		while(curVarExprn != NULL){
			if(curVarExprn->getVar() == var){
				return curVarExprn->getExpr();
			}
			curVarExprn = curVarExprn->getNextVarExprn();
		}
		curForLet = curForLet->getNextForLet();
	}

	// if we haven't found the variable yet, 
	// then it isn't in the current flwr
	// so we return empty string
	return ""; 
};

bool flwr::replaceVar(string& expr){

	int exprLength = expr.length();
	int exprPlace = 0;
	string trash = "";

	string var = "";
	string varVal = "";
	string returnVal = "";
	
	int xPathCount = 0;

	while(exprPlace < exprLength && expr[exprPlace] != '$'){
		trash = trash + expr[exprPlace];
		exprPlace++;
	}

	if(exprPlace < exprLength){
		var = expr[exprPlace];
		exprPlace++;
	}

	while(exprPlace < exprLength && (
		  (expr[exprPlace] >= 'A' && expr[exprPlace] <= 'Z') ||
		  (expr[exprPlace] >= 'a' && expr[exprPlace] <= 'z') ||
		  (expr[exprPlace] >= '0' && expr[exprPlace] <= '9') )){ 

		// || OTHER CASES??

		var = var + expr[exprPlace];
		exprPlace++;
	}


	if(var != ""){
		varVal = searchForVariableDef(var);
		returnVal = trash + varVal + expr.substr(exprPlace);
		expr = returnVal;
		return true;
	}else{
		return false;
	}

};

void flwr::getAllVarExprns(string ** allVars){

	int allVarsCounter = 0;
	forLets* curForLet = firstForLet;
	varExprns* curVarExprn;
	
	while(curForLet != NULL){
		curVarExprn = curForLet->getFirstVarExprn();
		while(curVarExprn != NULL){
			string curExprn = curVarExprn->getExpr();
			while(replaceVar(curExprn)){
			}
			allVars[allVarsCounter] = new string(curExprn);
			allVarsCounter++;
			curVarExprn = curVarExprn->getNextVarExprn();
		}
		curForLet = curForLet->getNextForLet();
	}
	allVars[allVarsCounter] = NULL;

	return;
};

