#ifndef flwr_h
#define flwr_h

#include <string>

using namespace std;

class varExprns{

public:

	varExprns(string var, string exp);
	~varExprns();
	varExprns * getNextVarExprn();
	string getVar();
	string getExpr();
	void addVarExprn(string var, string exprn);

private:

	string variable;
	string expression;
	varExprns * next;

};

class forLets{

public:

	forLets(bool newIsFor);
	~forLets();
	varExprns* getFirstVarExprn();
	forLets * getNextForLet();
	void addVarExprn(string var, string exprn);
	void addForLet(forLets* newForLet);

private:

	bool isFor;
	varExprns * firstVarExprn;
	forLets * next;

};

class flwr{

public:

	flwr();
	~flwr();
	void addForLet(forLets * newForLet);
	forLets * getFirstForLet();
	string getWhere();
	string getReturn();
	void setWhere(string newWhere);
	void setReturn(string newReturn);

	string ** getReturnXPaths();
	string ** getWhereXPaths();
	string searchForVariableDef(string var);
	void getAllVarExprns(string ** allVars);

private:

	string ** getXPaths(string expr);

	bool replaceVar(string& expr);
	
	forLets * firstForLet;
	string whereExpr;
	string returnExpr;
	int numFors;
	int numLets;
	int numXPaths;

};

#endif