
#include <string>
#include <iostream>
#include <fstream>
#include "token.h"
#include "node.h"
#include "pattern.h"
#include "patternlist.h"
//#include "hierarchy.h"
#include "process.h"
#include "flwr.h"
#include "xquery.h"
#include "dualhierarchy.h"

//#include "MD5Checksum.h"

using namespace std;


const int MAX_XPATHS = 1000;

void printUsage(){

	cout << "You have used the program incorrectly." << endl;
	cout << "Here is a list of valid command line " << endl;
	cout << "flags. It is suggested that you use at " << endl;
	cout << "least the -t -d -e -g flags."<< endl;
	cout << endl;
	cout << "FLAGS\t\tFUNCTION:" << endl;
	cout << "-t" << "\t\t" << "followed by input text filename (and path)" << endl;
	cout << "-d" << "\t\t" << "followed by output dot filename (and path)" << endl;
	cout << "-g" << "\t\t" << "followed by output gif filename (and path)" << endl;
	cout << "-e" << "\t\t" << "followed by dot.exe filename (and path)" << endl;
	cout << "-n" << "\t\t" << "graph labels will be numbers rather than expressions" << endl;
	cout << "-x" << "\t\t" << "input file is XPaths, not XQueries" << endl;
	cout << "-v" << "\t\t" << "if parsing XQueries, will consider all XPath expressions in variable assignment" << endl;
	cout << "-s" << "\t\t" << "if parsing XQueries, will consider all sub XPath expressions" << endl;
	cout << "-p" << "\t\t" << "if parsing XQueries, will show what part of the XQuery the XPath represents" << endl;
	cout << "-c" << "\t\t" << "if parsing XQueries, will collapse nodes into a single entry" << endl;

	cout << endl;
	cout << "sample usage: containment.exe -t c:\\textfile.txt -d c:\\dotfile.dot -g c:\\giffile.gif -d c:\\dotpath\\dot.exe -n -x -v -s -p" << endl;
	cout << endl;

};


/*
void addPattern(int x, patternlist* rootCounter, pattern ** xmlArray, patternlist ** subPatterns, patternlist ** equivPatterns )
{
	patternlist* prevCounter = NULL;
	bool addedYet = false;
	bool quit = false;
	while(rootCounter != NULL && !quit){
		bool newIsBigger = xmlArray[x]->DynamicProgrammingAlgorithm(rootCounter->getCurrent());
		bool newIsSmaller = rootCounter->getCurrent()->DynamicProgrammingAlgorithm(xmlArray[x]);
		if(newIsBigger && !newIsSmaller){
			subPatterns[x] = new patternlist(rootCounter->getCurrent());
			rootCounter->setCurrent(xmlArray[x]);
		}else if(newIsSmaller && !newIsBigger){
			addPattern(x,subPatterns[rootCounter->getCurrent()->getIndex()], xmlArray, subPatterns, equivPatterns);
		}else if(newIsSmaller && newIsBigger){
			// equivalent!
			if(equivPatterns[rootCounter->getCurrent()->getIndex()] == NULL){
				equivPatterns[rootCounter->getCurrent()->getIndex()] = new patternlist(xmlArray[x]);
			}else{
				equivPatterns[rootCounter->getCurrent()->getIndex()]->addItem(xmlArray[x]);
			}
		}
		prevCounter = rootCounter;
		rootCounter = rootCounter->getNext();
	}
	if(!addedYet){
		if(prevCounter != NULL){
			prevCounter->addItem(xmlArray[x]);
		}else{
			rootCounter = new patternlist(xmlArray[x]);
		}
	}
};
*/

int main(int argc, char* argv[])
{
	///////////////// NEW CODE!! //////////////////
	///////////////////////////////////////////////
/*
	ifstream* inputFile = new ifstream;
	inputFile->open("E:\\testxquery.txt");
	xquery xqueryInstance;

	flwr** xQueries;
	xQueries = xqueryInstance.xQueryParse(inputFile);

	pattern** xPaths = new pattern*[MAX_XPATHS];
	int xPathCount = 0;
	int xQueryCount = 0;
	while(xQueries[xQueryCount] != NULL){
		string ** whereXPath = xQueries[xQueryCount]->getWhereXPaths();
		if (whereXPath != NULL){
			for (int h = 0; whereXPath[h] != NULL; h++){
				cout << xQueryCount << ":  " << *(whereXPath[h]) << endl;
				xPaths[xPathCount] = new xPath(xPathCount, *(whereXPath[h]), xQueryCount, "where");
				xPathCount++;
			}
		}

		string ** returnXPath = xQueries[xQueryCount]->getReturnXPaths();
		if (returnXPath != NULL){
			for (int g = 0; returnXPath[g] != NULL; g++){
				cout << xQueryCount << ":  " << *(returnXPath[g]) << endl;
				xPaths[xPathCount] = new xPath(xPathCount, *(returnXPath[g]), xQueryCount, "return");
				xPathCount++;
			}
		}

		delete [] whereXPath;
		delete [] returnXPath;

		delete xQueries[xQueryCount];
		xQueryCount++;
	}

	for (int i = xPathCount; i < MAX_XPATHS; i++){
		xPaths[i] = NULL;
	}

	if(xQueries != NULL){
		delete [] xQueries;
	}

	return 0;

	*/
	///////////////////////////////////////////////
	//////////////// END NEW CODE /////////////////

	bool printLabels = true;
	string txtFilename = "e:\\XPath\\exprn\\xpathfile2.txt";
	string dotFilename = "e:\\XPath\\dot\\xpathfile2.dot";
	string gifFilename = "e:\\XPath\\graph\\xpathfile2.gif";
	string execDotPath = "e:\\XPath\\dot.exe";
	bool parseQueries = true;
	bool showAllVariables = false;
	bool showAllSubPaths = false;
	bool showSource = false;
	bool collapseNodes = false;
	bool onlyXPaths = false;
	int width = 20;
	int height = 10;


	// TEMP XQUERY TESTING
	///////////////////////////////////////
	onlyXPaths = true;
	parseQueries = true;
	showAllSubPaths = true;
	showAllVariables = true;
	collapseNodes = true;
	//showSource = true;
	printLabels = true;
	txtFilename = "e:\\XPath\\exprn\\testxquery.txt";
	dotFilename = "e:\\XPath\\dot\\testxquery.dot";
	gifFilename = "e:\\XPath\\graph\\testxquery.ps";
	////////////////////////////////////////

	int a = 0;
	while (argv[a] != NULL && a<10){
		if (argv[a][1] != NULL){
			if(argv[a][0] == '-' && argv[a][1] == 'n'){
				printLabels = false;
			}else if(argv[a][0] == '-' && argv[a][1] == 'x'){
				parseQueries = false;
			}else if(argv[a][0] == '-' && argv[a][1] == 'v'){
				showAllVariables = true;
			}else if(argv[a][0] == '-' && argv[a][1] == 's'){
				showAllSubPaths = true;
			}else if(argv[a][0] == '-' && argv[a][1] == 'p'){
				showSource = true;
			}else if(argv[a][0] == '-' && argv[a][1] == 'c'){
				collapseNodes = true;
			}else{
				//improper usage
				//printUsage();
			}
		}else{
			//improper usage
			//printUsage();
		}
		if(argv[a][2] != NULL){
			if(argv[a][0] == '-' && argv[a][1] == 't'){
				txtFilename = argv[a];
				txtFilename = txtFilename.substr(2);
			}else if(argv[a][0] == '-' && argv[a][1] == 'd'){
				dotFilename = argv[a];
				dotFilename = dotFilename.substr(2);
			}else if(argv[a][0] == '-' && argv[a][1] == 'g'){
				gifFilename = argv[a];
				gifFilename = gifFilename.substr(2);
			}else if(argv[a][0] == '-' && argv[a][1] == 'e'){
				execDotPath = argv[a];
				execDotPath = execDotPath.substr(2);
			}else{
				// improper usage
				//printUsage();
			}
		}else{
			// improper usage
			//printUsage();
		}
		a++;
	}

	//pattern** xmlArray;
	//xmlArray = new pattern*[MAX_XPATHS];

	pattern** xPaths = new pattern*[MAX_XPATHS];
	int xPathCount = 0;

	if(parseQueries){

		ifstream* inputFile = new ifstream;
////////////////////////////////////////////////////////////
//		txtFilename = "e:\\testxquery.txt";
//		showAllVariables = true;
////////////////////////////////////////////////////////////

		inputFile->open(txtFilename.c_str());
		xquery xqueryInstance;

		flwr** xQueries;
		xQueries = xqueryInstance.xQueryParse(inputFile);

		int xQueryCount = 0;
		while(xQueries[xQueryCount] != NULL){
			if(showAllVariables){
				string ** allVars = new string*[100];
				xQueries[xQueryCount]->getAllVarExprns(allVars);
				int varCount = 0;
				while(allVars[varCount] != NULL){
					cout << xQueryCount << ":  " << *(allVars[varCount]) << endl;
					xPaths[xPathCount] = new pattern(*(allVars[varCount]), xPathCount, xQueryCount, "variable");
					xPathCount++;
					varCount++;
				}
			}

			string ** whereXPath = xQueries[xQueryCount]->getWhereXPaths();
			if (whereXPath != NULL){
				for (int h = 0; whereXPath[h] != NULL; h++){
					cout << xQueryCount << ":  " << *(whereXPath[h]) << endl;
					xPaths[xPathCount] = new pattern(*(whereXPath[h]), xPathCount, xQueryCount, "where");
					xPathCount++;
				}
			}

			string ** returnXPath = xQueries[xQueryCount]->getReturnXPaths();
			if (returnXPath != NULL){
				for (int g = 0; returnXPath[g] != NULL; g++){
					cout << xQueryCount << ":  " << *(returnXPath[g]) << endl;
					xPaths[xPathCount] = new pattern(*(returnXPath[g]), xPathCount, xQueryCount, "return");
					xPathCount++;
				}
			}

			delete [] whereXPath;
			delete [] returnXPath;

			delete xQueries[xQueryCount];
			xQueryCount++;
		}



		if(xQueries != NULL){
			delete [] xQueries;
		}

	}else{

		ifstream myExpressions;
		myExpressions.open(txtFilename.c_str());

		int xmlCounter = 0;
		string query;
		myExpressions >> query;
		while (query != ""){

	//		if (xmlCounter == maxArraySize){
	//			// resize array of patterns
	//			pattern ** newXMLArray = new pattern*[maxArraySize*2];
	//			for(int i=0; i < xmlCounter; i++){
	//				newXMLArray[i] = xmlArray[i];
	//			}
	//			maxArraySize = maxArraySize*2;
	//			delete [] xmlArray;
	//			xmlArray = newXMLArray;
	//		}
			if(query != ""){
				xPaths[xPathCount] = new pattern(query, xPathCount, -1, "");
				xPathCount++;
			}
			myExpressions >> query;
		}
	}

	if(showAllSubPaths){
		int OriginalxPathCount = xPathCount;
		string** subPaths;
		for (int i = 0; i < OriginalxPathCount; i++){
			//subPaths = 
				subPaths = xPaths[i]->getSubPaths();
			int j = 0;
			while (subPaths[j] != NULL){
				if(*subPaths[j] != ""){
					xPaths[xPathCount] = new pattern(*(subPaths[j]), xPathCount, xPaths[i]->getQueryNumber(), "subpath");
					xPathCount++;
				}
				j++;
			}
		}

	}

	for (int i = xPathCount; i < MAX_XPATHS; i++){
		xPaths[i] = NULL;
	}

	dualhierarchy * myTree = new dualhierarchy(xPaths, xPathCount);



	for(int v = 0; v < xPathCount; v++){
		myTree->addPattern(v);
	}

	if(altResults){
		myTree->sameHierarchyLevelContainmentFinder();
	}

	myTree->eliminateRedundantEdges();

	myTree->printToDot(dotFilename, !printLabels, showSource, collapseNodes, onlyXPaths, width, height);

	myTree->printPathsToDot(dotFilename.substr(0,dotFilename.length() - 4) + "paths.dot");

//	char *md5args[3];
//	md5args[0] = "md5";
//	md5args[1] = "C:\\Inetpub\\wwwroot\\dots\\mytest.dot";
//	md5args[2] = NULL;
//	_spawnv(_P_WAIT,"C:\\md5\\md5.exe", md5args);


//	CMD5Checksum DAMMIT;

//	filePath = DAMMIT.GetMD5(filePath);

	gifFilename = "-o" + gifFilename;

	char *dotargs[5];
	dotargs[0] = "dot";
	dotargs[1] = "-Tps";
	dotargs[2] = (char*)gifFilename.c_str();
	dotargs[3] = (char*)dotFilename.c_str();
	dotargs[4] = NULL;

	_spawnv(_P_WAIT, execDotPath.c_str(), dotargs);


/*
	patternlist * treeRoots = new patternlist(xmlArray[0]);

	patternlist ** subPatterns = new patternlist*[xmlCounter];
	patternlist ** equivPatterns = new patternlist*[xmlCounter];

	for (int q = 0; q < xmlCounter; q++){
		subPatterns[q] = NULL;
		equivPatterns[q] = NULL;
	}

	bool newIsSmaller = false;
	bool newIsBigger = false;
	bool addedYet = false;
	bool quit = false;
	patternlist * rootCounter;
	patternlist * prevCounter;

	for(int x=1; x < xmlCounter; x++){
		rootCounter = treeRoots;
		addedYet = false;
		quit = false;
		while(rootCounter != NULL && !quit){
			newIsBigger = xmlArray[x]->DynamicProgrammingAlgorithm(rootCounter->getCurrent());
			newIsSmaller = rootCounter->getCurrent()->DynamicProgrammingAlgorithm(xmlArray[x]);
			if(newIsBigger && !newIsSmaller){
				subPatterns[x] = new patternlist(rootCounter->getCurrent());
				rootCounter->setCurrent(xmlArray[x]);
			}else if(newIsSmaller && !newIsBigger){

			}else if(newIsSmaller && newIsBigger){
				// equivalent!
				if(equivPatterns[rootCounter->getCurrent()->getIndex()] == NULL){
					equivPatterns[rootCounter->getCurrent()->getIndex()] = new patternlist(xmlArray[x]);
				}else{
					equivPatterns[rootCounter->getCurrent()->getIndex()]->addItem(xmlArray[x]);
				}
			}
			prevCounter = rootCounter;
			rootCounter = rootCounter->getNext();
		}
		if(!addedYet){
			prevCounter->addItem(xmlArray[x]);
		}
	}
*/
	// should do this in a smarter manner: like store roots and step down each tree, looking for place.

/*	
	for(int j = 0; j < xmlCounter; j++){
		for(int k = 0; k < xmlCounter; k++){
			if(j!=k){
				if(xmlArray[j]->DynamicProgrammingAlgorithm(xmlArray[k])){
					// should do something more interesting than just print
					cout << "The expression " << xmlArray[k]->getXPath() << " is contained in the expression " << xmlArray[j]->getXPath() << endl << endl;
				}
			}
		}
	}

	cout << "test" << endl;
	string testt;
	cin >> testt;
*/


	int deleteCounter = 0;
	while(xPaths[deleteCounter] != NULL){
		delete xPaths[deleteCounter];
		deleteCounter++;
	}
	delete [] xPaths;

	return 0;
}


/*

int main(){


	string xml1, xml2;

	xml1 = "/*//*/*[*][*[*]]/*";
	xml2 = "/bib//book/author[first][address[zip]]/last";

	pattern * testPattern = new pattern(xml1);

	pattern * testPattern2 = new pattern(xml2);

	bool test1 = testPattern->DynamicProgrammingAlgorithm(testPattern2);
	bool test2 = testPattern2->DynamicProgrammingAlgorithm(testPattern);

	cout << "xml1 = " << xml1 << endl;
	cout << "xml2 = " << xml2 << endl << endl;
	
	cout << "According to the dynamic programming algorithm: " << endl;

	if (test1) {
		cout << "xml2 is contained in xml1" << endl;
	}else{
		cout << "xml2 is not contained in xml1" << endl;
	}

	if (test2){
		cout << "xml1 is contained in xml2" << endl;
	}else{
		cout << "xml1 is not contained in xml2" << endl;
	}

	cout << "xml1 counter: " << testPattern->belowCounter << endl;
	cout << "xml2 counter: " << testPattern2->belowCounter << endl;

//	delete testPattern;


	string command = "";
	string search = "";
	int num1 = 0;
	int num2 = 0;
	
	cout << endl << "now you can examine xml1 in more detail:" << endl;

	while (command != "q"){

		cout << endl << "p: print a node value, r: relationships, f: find child, q: quit: ";
		cin >> command;
		if (command == "p"){
			cout << endl << "Enter a node number (0 to " << testPattern->getNumNodes() - 1 << "):";
			cin >> num1;
			testPattern->printNode(num1);
		}else if (command == "r"){
			cout << endl << "Enter a parent number (0 to " << testPattern->getNumNodes() - 1 << "):";
			cin >> num1;
			cout << endl << "Enter a child number (0 to " << testPattern->getNumNodes() - 1 << "):";
			cin >> num2;
		
			cout << "Relationship is: " << testPattern->isBelowFast(num1, num2) << endl;
		}else if (command == "f"){
			
			cout << "Enter a node number (0 to " << testPattern->getNumNodes() - 1 << "):";
			cin >> num1;
			cout << "Enter a search string:";
			cin >> search;
			cout << "Enter exact search depth (negative corresponds to greater than):";
			cin >> num2;

			int numMatches = 0;
			int * matches = NULL;
//			matches = testPattern->hasChild(num1,num2,search, numMatches);
			
			if (numMatches == 0){
				cout << "Failed to find " << search << " at a depth of " << num2 << " below node " << num1;
			}else{
				cout << "The following node numbers matched the criteria: " << matches[0];
				for (int i = 1; i < numMatches; i++){
					cout << ", " << matches[i];
				}
				delete [] matches;
			}

		} // else if

	} // while


	return 0;

};

*/
