
#include "node.h"

node::node()
{

	label = "";
	nodeID = 0;
	numChildren = 0;
	relationToParent = 0;
	childRoot = NULL;
	isReturned = false;

};

node::~node()
{

	if (childRoot !=NULL){
		delete childRoot;
	}

}

bool node::isReturnNode()
{
	return isReturned;
};

void node::setReturnNode(bool newVal)
{
	isReturned = newVal;
};

void node::setParent(int newID)
{
	parentID = newID;
};

int node::getParent()
{
	return parentID;
};

node::node(string nodeVal, int nodeNum)
{
	label = nodeVal;
	nodeID = nodeNum;
	numChildren = 0;
	childRoot = NULL;
	isReturned = false;
};

string node::getLabel(){
	return label;
};

void node::setLabel(string newVal)
{
	label = newVal;
};
	
void node::setID(int newID)
{
	nodeID = newID;	
};

int node::getID()
{
	return nodeID;	
};

bool node::isStar()
{
	return (label=="*");	
};

void node::addChild(int childNum, int childRelationship)
{

	nodeChild* temp = childRoot;
	nodeChild* prev;

	if (temp == NULL){
		childRoot = new nodeChild(childNum, childRelationship);
	}else{

		// this can be slightly more efficient if we use numNodes?;
		while(temp != NULL){ 
			prev = temp;
			temp = temp->getNext();
		}
		prev->setNext(childNum, childRelationship);
	}

	numChildren++;

};

int node::getNumChildren()
{
	return numChildren;
};

void node::setRelationToParent(int newRelation)
{
	relationToParent = newRelation;
};

int node::getRelationToParent()
{
	return relationToParent;
};

nodeChild::nodeChild(int nodeNum, int childRelationship)
{

	nextNodeChild = NULL;
	thisNode = nodeNum;
	relationship = childRelationship;

};

nodeChild::~nodeChild()
{
	nodeChild* toBeDeleted = getNext();
	
	if (toBeDeleted != NULL){
		delete toBeDeleted;
	}

};

nodeChild* nodeChild::getNext()
{

	return nextNodeChild;

};

void nodeChild::setNext(int nodeNum, int childRelationship)
{

	nextNodeChild = new nodeChild(nodeNum, childRelationship);	

};

int nodeChild::getVal()
{

	return thisNode;

};

nodeChild* node::getChildRoot()
{

	return childRoot;

};

int nodeChild::getRelationship()
{

	return relationship;

};


