#include "pattern.h"
#include <iostream>

const int MAXSUBPATHS = 20; 

pattern::pattern(string xml, int index, int queryNum, string type)
{
	returnNode = 0;
	subPaths = new string*[MAXSUBPATHS];
	subPathCount = 0;
	consumedXPath = "";
	for (int i = 0; i < MAXSUBPATHS; i++){
		subPaths[i] = NULL;
	}
	numNodes = 0;
	xPathExpr = xml;
	xQueryNumber = queryNum;
	xPathType = type;
	// predict is precise right now.  will it always be?
	int numberOfNodesPredict = parseToTokens() + 1; // +1 for blank root - should I really make a blank root?	
	numberOfNodesPredict -= eliminateStars();
	numberOfNodesPredict++; // Quick hack to fix bug?
	currentToken = tokenList;
	buildTree(numberOfNodesPredict);
	delete tokenList;
	tokenList = NULL;
	belowCounter = 0;

	arrayIndex = index;

//	subPatterns = NULL;
//	equivalentPatterns = NULL;

};

pattern::~pattern()
{
	if (allnodes != NULL){
		delete [] allnodes;
	}

	for (int i=0; i<numNodes; i++){
		delete [] relationships[i];
	}
	delete [] relationships;

};

int pattern::eliminateStars()
{

	token * starCheckToken = tokenList;
	token * previousToken = NULL;
	token * tempPreviousToken = NULL;

	int elimCounter = 0;
	int joinValue = 0;

	bool foundDesc = false;

	while (starCheckToken != NULL){
		joinValue = 0;
		foundDesc = false;
		//bool quit = false;
		tempPreviousToken = previousToken;
		while (starCheckToken->next() != NULL && starCheckToken->value() == "*"){
			
			if(tempPreviousToken->join() == 1){
				if(joinValue >= 0){
					joinValue += 1;
				}else{
					joinValue -= 1;
				}
			}else if(tempPreviousToken->join() == -1){
				foundDesc = true;
				if(joinValue >= 0){
					joinValue = - joinValue - 1;
				}else{
					joinValue -= 1;
				}
			}else if(starCheckToken->value() == "[" || starCheckToken->value() == "]"){
				joinValue = 0;
				break;
					// if this happens, we probably can't eliminate the *
			}

			/////////// advance counter //////////////
			if(starCheckToken->next() != NULL){
				tempPreviousToken = starCheckToken;
				starCheckToken = starCheckToken->next();

				//////////////////////////////////////////
				
				if(starCheckToken->join() == 1){
					if(joinValue >= 0){
						joinValue += 1;
					}else{
						joinValue -= 1;
					}
				}else if(starCheckToken->join() == -1){
					foundDesc = true;
					if(joinValue >= 0){
						joinValue = - joinValue - 1;
					}else{
						joinValue -= 1;
					}
				}else if(starCheckToken->value() == "[" || starCheckToken->value() == "]"){
					// abandon ship!  we probably can't eliminate the * in this case
					joinValue = 0;
					break;
				}

				/////////// advance counter //////////////
				if(starCheckToken->next() != NULL){
					tempPreviousToken = starCheckToken;
					starCheckToken = starCheckToken->next();
				}else{
					if(joinValue == 1 || joinValue == -1 || !foundDesc){
						joinValue = 0;
					}
					starCheckToken = NULL;
				}
				//////////////////////////////////////////
			}else{
				if(joinValue == 1 || joinValue == -1 || !foundDesc){
					joinValue = 0;
				}
				starCheckToken = NULL;
			}
		}

		if(joinValue != 0 && foundDesc){
			elimCounter += abs(joinValue) - 1;
			tempPreviousToken->setNextPtr(NULL);
			delete previousToken->next();
			previousToken->changeValue(joinValue);
			previousToken->setNextPtr(starCheckToken);
		}

		else if(starCheckToken != NULL){
			previousToken = starCheckToken;
			starCheckToken = starCheckToken->next();
		}
	}

	return elimCounter;

};

// converts xPathExpr string to token linked list.
//  stored in member tokenList.

int pattern::parseToTokens()
{
	int tokenCounter = 0;
	tokenList = new token();
	token * current = tokenList;
	string temp = "";
	string xml = xPathExpr;

	for (int stringCounter = 0; stringCounter < xml.length(); stringCounter++)
	{

		if (xml[stringCounter] == '[' || xml[stringCounter] == ']'){
			//tokenCounter++
			bool breakTime = false;
			if (temp != ""){
				if(temp == "/" && xml[stringCounter] == '['){
					// we will treat person/[id] as the same as person[id]
					current->setNext("[",0);
					breakTime = true;
				}else if(temp == "/"){
					current->setNext("/",1);
				}else if(temp == "//"){
					current->setNext("/",-1);
				}else{
					current->setNext(temp,0);
				}
				current = current->next();
				temp = "";
				//tokenCounter++;
			}
			if(!breakTime){
				if(xml[stringCounter] == '['){
					current->setNext("[",0);
				}else{
					current->setNext("]",0);
				}
			
				current = current->next();
			}
			//tokenCounter++;
		}else if(xml[stringCounter] == '/'){
			if(temp == "/"){
				current->setNext("/",-1);
				current = current->next();
				temp = "";
				//tokenCounter++;
			}else if(temp == ""){
				temp = "/";
			}else{
				// shouldn't have to use this if:
				//if(temp[temp.length()-1] != '/'){
					current->setNext(temp,0);
					current = current->next();
					temp = "/";
					//tokenCounter++;
				//}
			}
		}else if(xml[stringCounter] != '/' && temp == "/"){
			current->setNext("/",1);
			current = current->next();
			temp = xml[stringCounter];
			tokenCounter++;
		}else{
			if(temp == ""){
				tokenCounter++;
			}
			temp = temp + xml[stringCounter];
		}
	}
	
	if (temp != ""){
		if(temp == "/"){
			current->setNext("/",1);
		}else if(temp == "//"){
			current->setNext("/",-1);
		}else{
			current->setNext(temp,0);
		}

		current = current->next();
		temp = "";
		//tokenCounter++;
	}

	return tokenCounter;

};


void pattern::buildTree(int numberOfNodesPredict)
{

	numNodes = 0;

	int parentType = 0;

   // THE ADDED +2 is +1 so //* can be added, +1 for safety factor.
 	allnodes = new node[numberOfNodesPredict+ 2];	

	relationships = new int*[numberOfNodesPredict];

	for (int i=0; i<numberOfNodesPredict; i++){
		relationships[i] = new int[numberOfNodesPredict];
		for (int j=0; j<numberOfNodesPredict; j++){
			relationships[i][j] = 0;
		}
	}

	int nextIndex = 0;

	while (currentToken->value() == "/" || currentToken->value() == "."){
		if(currentToken->join() != 0){
			parentType = currentToken->join();
		}
		consumedXPath += currentToken->value();
		if(currentToken->value() == "/" && currentToken->join() < 0){
			consumedXPath += "/";
		}
		currentToken = currentToken->next();
		
	}

	// maybe need other checks to see what first symbol is
	// is this the right thing to do if query doesn't start with a slash?
	if(parentType == 0){
		parentType = 1;
	}

	allnodes[numNodes].setID(numNodes);
	allnodes[numNodes].setLabel(currentToken->value() );

	returnNode = numNodes;
	numNodes++;
	consumedXPath += currentToken->value();
	if(currentToken->value() == "/" && currentToken->join() < 0){
		consumedXPath += "/";
	}
	currentToken = currentToken->next();
	subPaths[subPathCount] = new string(consumedXPath);
	subPathCount++;

	while (currentToken->value() == "["){
		currentToken = currentToken->next();
		recurseBuild(0, 1, 1); // what is the deal with this line??
		if (currentToken->value() == "]"){
			consumedXPath += currentToken->value();
			currentToken = currentToken->next();
		}else{
			// raise error - never got an end bracket
			cout << "Ach!  never read in an end bracket!" << endl;
		}
	}
	
	if(currentToken->value() == "/" && currentToken->join() != 0){
		parentType = currentToken->join();
		consumedXPath += currentToken->value();
		if(currentToken->value() == "/" && currentToken->join() < 0){
			consumedXPath += "/";
		}
		currentToken = currentToken->next();
		recurseBuild(0, parentType, 0);
	}else{
		// first symbol is a character, not a slash
		// am I doing the right thing here? (by assuming slash)
		//parentType = currentToken->join();
		//currentToken = currentToken->next();
		recurseBuild(0, parentType, 0);
	}

	allnodes[returnNode].setReturnNode(true);

};

void pattern::recurseBuild(int parentIndex, int parentType, int bracketCount)
{
	if (currentToken == NULL)
		return;

	int myNum = numNodes; // used for leaf counting only

	// we should only get inside this 'if' in situations like [//test]
	// am I doing the right thing in this case?
	// or can [/test] never appear?  is [/test] legal? perhaps it can be ignored?
	if (currentToken->value() == "/" && currentToken->join() == 1){
		// this specifies the root element. . . what do we do about this?
	}else if(currentToken->value() == "/" && currentToken->join() != 1){
		parentType = currentToken->join();
		consumedXPath += currentToken->value();
		currentToken = currentToken->next();
	}

	allnodes[numNodes].setID(numNodes);
	allnodes[numNodes].setLabel(currentToken->value() );
	allnodes[numNodes].setParent(parentIndex);
	allnodes[numNodes].setRelationToParent(parentType);
	allnodes[parentIndex].addChild(numNodes, parentType);
	
	consumedXPath += currentToken->value();
	if(currentToken->value() == "/" && currentToken->join() < 0){
		consumedXPath += "/";
	}
	currentToken = currentToken->next();
	subPaths[subPathCount] = new string(consumedXPath);
	for (int k = 0; k < bracketCount; k++){
		*subPaths[subPathCount] = *subPaths[subPathCount] + "]";
	}
	subPathCount++;

	// establish relationships here - actually maybe can be rid of this method
//
	if(parentType > 0){
		relationships[parentIndex][numNodes] = parentType;
		for(int i = 0; i < numNodes; i++){
			if(relationships[i][parentIndex] > 0){
				relationships[i][numNodes] = relationships[i][parentIndex] + parentType;
			}else if(relationships[i][parentIndex] < 0){
				relationships[i][numNodes] = relationships[i][parentIndex] - parentType;
			}
		}
	}else if(parentType < 0){
		relationships[parentIndex][numNodes] = parentType;
		for(int i = 0; i < numNodes; i++){
			if(relationships[i][parentIndex] > 0){
				relationships[i][numNodes] = -relationships[i][parentIndex] + parentType;
			}else if(relationships[i][parentIndex] < 0){
				relationships[i][numNodes] = relationships[i][parentIndex] + parentType;
			}
		}
	}

	parentIndex = numNodes;

	// if node is not in brackets, set as return node
	if(bracketCount == 0){
		returnNode = numNodes;
	}

	numNodes++;

	if (currentToken == NULL){
		return;
	}

	// take care of all branching before descending
	while (currentToken->value() == "["){ 
		consumedXPath += currentToken->value();
		currentToken = currentToken->next();
		recurseBuild(parentIndex, 1, bracketCount + 1);
		if (currentToken->value() == "]"){
			consumedXPath += currentToken->value();
			currentToken = currentToken->next();
			if (currentToken == NULL) return;
		}else{
			// raise error - never got an end bracket
			cout << "Ach!  never read in an end bracket!  read '" << currentToken->value() << "' instead." << endl;
		}
	}
	
	// descend deeper into tree
	if(currentToken->join() != 0){
		parentType = currentToken->join();
		consumedXPath += currentToken->value();
		if(currentToken->value() == "/" && currentToken->join() < 0){
			consumedXPath += "/";
		}
		currentToken = currentToken->next();
		recurseBuild(parentIndex, parentType, bracketCount);

	}else{
		// I think this means it is a leaf. . .
	}

	return;
};


int pattern::findOp(string source, string& op, int& opLength){

	int pos = -1;
	op = "";
	opLength = 0;

	pos = source.find(">=");
	if(pos >= 0){
		op = ">="; opLength = 2; return pos;
	}
	pos = source.find("<=");
	if(pos >= 0){
		op = "<="; opLength = 2; return pos;
	}
	pos = source.find("!=");
	if(pos >= 0){
		op = "!="; opLength = 2; return pos;
	}
	pos = source.find("<>");
	if(pos >= 0){
		op = "<>"; opLength = 2; return pos;
	}
	pos = source.find("=");
	if(pos >= 0){
		op = "="; opLength = 1; return pos;
	}
	pos = source.find(">");
	if(pos >= 0){
		op = ">"; opLength = 1; return pos;
	}
	pos = source.find("<");
	if(pos >= 0){
		op = "<"; opLength = 1; return pos;
	}


	return -1;

};

bool pattern::labelMatch(string sub, string super){

	if(super == "*")
		return true;
	else if(super == sub)
		return true;
	else{
		int subOpPos, superOpPos;
		string subField, subValue, superField, superValue;
		string subOp, superOp;
		int subOpLength, superOpLength;
		subOpPos = findOp(sub, subOp, subOpLength);

		if(subOpPos >= 0){
			subField = sub.substr(0, subOpPos);
			subValue = sub.substr(subOpPos+subOpLength);
			
			superOpPos = findOp(super, superOp, superOpLength);
			if(superOpPos >= 0){
				superField = super.substr(0, superOpPos);
				superValue = super.substr(superOpPos+superOpLength);
			}else{
				superField = super;
				superValue = "";
			}

			if(subField != superField)
				return false;

			if(superValue == "")
				return true;

			 // here is where we actually do the value comparisons
			if(subOp == ">="){
				if(superOp == ">="){
					if(subValue >= superValue)
						return true;
				}else if(superOp == ">"){
					if(subValue > superValue)
						return true;
				}else if(superOp == "<>" || superOp == "!="){
					if(subValue > superValue)
						return true;
				}else{
					return false;
				}
			}else if(subOp == "<="){
				if(superOp == "<="){
					if(subValue <= superValue)
						return true;
				}else if(superOp == "<"){
					if(subValue < superValue)
						return true;
				}else if(superOp == "<>" || superOp == "!="){
					if(subValue < superValue)
						return true;
				}
			}else if(subOp == "!=" || subOp == "<>"){
				if(superOp == "!=" || superOp == "<>"){
					if(subValue == superValue)
						return true;
				}
			}else if(subOp == "="){
				if(superOp == ">="){
					if(subValue >= superValue)
						return true;
				}else if(superOp == "<="){
					if(subValue <= superValue)
						return true;
				}else if(superOp == "!=" || superOp == "<>"){
					if(subValue != superValue)
						return true;
				}else if(superOp == "="){
					if(subValue == superValue)
						return true;
				}else if(superOp == ">"){
					if(subValue > superValue)
						return true;
				}else if(superOp == "<"){
					if(subValue < superValue)
						return true;
				}
			}else if(subOp == ">"){
				if(superOp == ">="){
					if(subValue >= superValue)
						return true;
				}else if(superOp == ">"){
					if(subValue >= superValue)
						return true;
				}else if(superOp == "<>" || superOp == "!="){
					if(subValue >= superValue)
						return true;
				}
			}else if(subOp == "<"){
				if(superOp == "<="){
					if(subValue <= superValue)
						return true;
				}else if(superOp == "<"){
					if(subValue <= superValue)
						return true;
				}else if(superOp == "<>" || superOp == "!="){
					if(subValue <= superValue)
						return true;
				}
			}

		}
	}
	
	return false;
};


// the bulk of the fast algorithm is built into this function
bool pattern::DynamicProgrammingAlgorithm(pattern * foreignPattern, bool matchReturnNodes)
{
	int foreignNumNodes = foreignPattern->getNumNodes();

	bool** homomorphisms = new bool*[numNodes];  // first index = local index
	int** D = new int*[numNodes];

	bool bigSuccess;
	bool smallSuccess;

	node* foreignAllNodes = foreignPattern->getAllNodes();

	for (int i = numNodes - 1; i >= 0; i--){

		homomorphisms[i] = new bool[foreignNumNodes];

		D[i] = new int[foreignNumNodes];

		nodeChild* root = allnodes[i].getChildRoot();  // this line is confusing - rename root?

		for(int j = foreignNumNodes - 1; j >= 0; j--){

			homomorphisms[i][j] = false;
			bigSuccess = false; 

			if (labelMatch(foreignAllNodes[j].getLabel(), allnodes[i].getLabel())
			&& (!matchReturnNodes || !allnodes[i].isReturnNode() || foreignAllNodes[j].isReturnNode())){

			//if (foreignAllNodes[j].getLabel() == allnodes[i].getLabel() || allnodes[i].getLabel() == "*"){

				// OLD VERSION
				// ********************************************************************
				bigSuccess = true;
				nodeChild* temp = root;
				while (temp != NULL){
					smallSuccess = false;

					if(temp->getRelationship() == 1){ // temp is a child edge
						
						nodeChild* newRoot = foreignAllNodes[j].getChildRoot();
						while(newRoot != NULL){
							if(homomorphisms[temp->getVal()][newRoot->getVal()] && newRoot->getRelationship() == 1){
								smallSuccess = true;
							}
							newRoot = newRoot->getNext();
						}
						
					}else if (temp->getRelationship() > 0){ 
						cout << "UH OH - SOMETHING WRONG IN STAR ELIM, CUS WE HAVE A RELATIONSHIP WITH VALUE " << temp->getRelationship() << endl;
					}else{
						// temp is a descendent edge
						
						// the bug in my code is probably at this point
						// I need to think about what should really be compared here
						if(D[temp->getVal()][j] >= abs(temp->getRelationship())){
							smallSuccess = true;
						}else{
							// bad!
						}
					}

					/*	for (int n = 0; n < foreignNumNodes; n++){
							if(homomorphisms[temp->getVal()][n]){

								int foreignHowFarBelow = foreignPattern->isBelowFast(j,n);

								//int foreignHowFarBelow = foreignPattern->isBelow(j,n);

								if (temp->getRelationship() > 0){
									if( temp->getRelationship() == foreignHowFarBelow ){
										smallSuccess = true;
									}
								}else{
									if(foreignHowFarBelow > 0){
										if(-temp->getRelationship() <= foreignHowFarBelow){
											smallSuccess = true;
										}
									}else{
										if(temp->getRelationship() >= foreignHowFarBelow){///// bad things happen here?
											smallSuccess = true;
										}
									}
								}
							}
						}	*/

					if (!smallSuccess){
						 bigSuccess = false;
					}
					temp = temp->getNext();
				}

				
				// END OLD VERSION
				// *********************************************************************

				if (bigSuccess){
					homomorphisms[i][j] = true;
				}

			} // end if label match

			// we'll try to calculate D right here I guess
			int d;

			if(bigSuccess){
				d = 0;
			}else{ 
				d = -1000;
			}

			nodeChild* xChildren = foreignAllNodes[j].getChildRoot();

			while(xChildren != NULL){
				if(D[i][xChildren->getVal()] + abs(xChildren->getRelationship()) > d){
					d = D[i][xChildren->getVal()] + abs(xChildren->getRelationship());
				}
				xChildren = xChildren->getNext();
			}

			if(d>=0){
				D[i][j] = d;
			}else{
				D[i][j] = -1000;
			}

		} // end for j
	} // end for i

	bool returnVal = false;
	for(int m=0; m<foreignNumNodes && !returnVal; m++){
		if(homomorphisms[1][m]){
			returnVal = true;
		}
	}

/*
  // prints out homomorphism table
	cout << "\t";

	for(int w=0; w<foreignNumNodes; w++){
		cout << foreignAllNodes[w].getLabel() << "\t";
	}

	cout << endl;

	for(int z=0; z<numNodes; z++){
		cout << allnodes[z].getLabel() << "\t";
		for(int y=0; y<foreignNumNodes; y++){
			cout << homomorphisms[z][y] << "\t";
		}
		cout << endl;
	}

*/
	for(int k=0; k<numNodes; k++){
		delete [] homomorphisms[k];
	}
	delete [] homomorphisms;

	return returnVal;

};

// this function could be replaced by looking up relationship in a table
// it would then run in constant time, rather than depending on the depth of the tree
// it will take more space, but might not take more time if table is built when tree is built.
// returns depth.
// 0 means is not below
// <0 means greater than or equal to abs().
int pattern::isBelow(int upperNodeNum, int lowerNodeNum)
{
	belowCounter++;
	if(upperNodeNum >=numNodes || lowerNodeNum >=numNodes){
		cout << "Error!  Called isBelow with invalid node number!" << endl;
		return 0;
	}

	if(lowerNodeNum < upperNodeNum){
		return 0;
	}else{

		int current = lowerNodeNum;
		int next;
		int nextRelationshipVal;

		int total = 0;

		while ( current != 0 && current != upperNodeNum){
			next = allnodes[current].getParent();
			nextRelationshipVal = allnodes[current].getRelationToParent();
			if (total > 0){
				if(nextRelationshipVal >= 0){
					total = total + nextRelationshipVal;
				}else{
					total = -total + nextRelationshipVal;
				}

			}else if (total == 0){
				total = nextRelationshipVal;
			}else{
				total = total - abs(nextRelationshipVal);
			}
			current = next;
		}

		if (current == upperNodeNum){
			return total;	
		}else{
			return 0;
		}
	}

};


int pattern::isBelowFast(int upperNodeNum, int lowerNodeNum)
{
	belowCounter++;
	if(lowerNodeNum < upperNodeNum){
		return 0;
	}else{
		return relationships[upperNodeNum][lowerNodeNum];
	}
};


node* pattern::getAllNodes()
{
	return allnodes;
};


int pattern::getNumNodes()
{
	return numNodes;
};


void pattern::printNode(int nodeNum)
{

	if(nodeNum < numNodes){
		cout << allnodes[nodeNum].getLabel() << endl;
	}else{
		cout << "Invalid node number.  Please choose a value between 0 and " << numNodes - 1 << endl;
	}

};

string pattern::getXPath()
{
	return xPathExpr;
};

string pattern::getPrintableXPath()
{

	string returnXPath = "";
	bool foundSlash = false;
	for (int i = 0; i < xPathExpr.length(); i++){
		if(xPathExpr[i] == '/'){
			foundSlash = true;
		}
		//if(foundSlash){
			if(xPathExpr[i] == '<' || xPathExpr[i] == '>' || xPathExpr[i] == '|' || xPathExpr[i] == '{' || xPathExpr[i] == '}' || xPathExpr[i] == '@'){
				returnXPath += "\\";
			}
			returnXPath += xPathExpr[i];
		//}
	}
	if(returnXPath == ""){
		returnXPath = "/";
	}

	return returnXPath;

};

string pattern::getXPathType()
{
	return xPathType;	
};

int pattern::getIndex()
{
	return arrayIndex;
};

int pattern::getQueryNumber()
{
	return xQueryNumber;
};

string** pattern::getSubPaths()
{
	return subPaths;
};

void pattern::addSlashSlashStar()
{

	allnodes[numNodes].setID(numNodes);
	allnodes[numNodes].setLabel("*");
	allnodes[numNodes].setParent(returnNode);
	allnodes[numNodes].setRelationToParent(-1);
	allnodes[returnNode].addChild(numNodes, -1);
	allnodes[returnNode].setReturnNode(false);
	allnodes[numNodes].setReturnNode(true);

	returnNode = numNodes;
	numNodes++;
	xPathExpr += "//*";
};


/*
void addSubPattern(pattern * newSub)
{
	if (subPatterns == NULL){
		subPatterns = new patternlist(newSub);
	}else{
		subPatterns->addItem(newSub);
	}
};

void addEquivalentPattern(pattern * newEquiv)
{
	if (equivalentPatterns == NULL){
		equivalentPatterns = new patternlist(newEquiv);
	}else{
		equivalentPatterns->addItem(newEquiv);
	}
};

patternlist * getSubPatterns()
{
	return subPatterns;
};

patternlist * getEquivalentPatterns()
{
	return equivalentPatterns;
};
*/
