
#ifndef pattern_h
#define pattern_h

#include "node.h"
#include <string>
#include "token.h"
//#include "patternlist.h"


using namespace std;

//enum relationship { NORELATION, HIERARCHY, CONTAINMENT };

class pattern{

public:

	pattern();

	pattern(string xml, int index, int queryNum, string type);

	~pattern();

	bool DynamicProgrammingAlgorithm(pattern * foreignPattern, bool matchReturnNodes);

	int isBelow(int upperNodeNum, int lowerNodeNum);
	int isBelowFast(int upperNodeNum, int lowerNodeNum);
	void printNode(int nodeNum);

	int getNumNodes();

	node * getAllNodes();

	int belowCounter; // ONLY FOR PERFORMANCE TESTING

	string getXPath();
	
	string getPrintableXPath();
	
	string getXPathType();

	int getQueryNumber();

	int getIndex();

	string** getSubPaths();

	void addSlashSlashStar();

/*
	void addSubPattern(pattern * newSub);
	void addEquivalentPattern(pattern * newEquiv);
	
	patternlist * getSubPatterns();
	patternlist * getEquivalentPatterns();
*/
private:

	int parseToTokens();

	int eliminateStars();

	int findOp(string source, string& op, int& opLength);

	bool labelMatch(string sub, string super);

	void buildTree(int numberOfNodesPredict);

	void recurseBuild(int parentIndex, int parentType, int bracketCount);

	int returnNode;

	string xPathExpr;

	string xPathType;

	string ** subPaths;
	
	string consumedXPath;

	int subPathCount;

	int xQueryNumber;

	node * allnodes;

	int ** relationships; // entry [i][j] represents j's depth below i.
//	int ** starlessrelationships;
//	int ** allrelationships;

	int numNodes;

//	int treeDepth; // get rid of this?
//	int numBranches; // get rid of this?

	token * tokenList;

	token * currentToken;
/*
	patternlist * subPatterns;

	patternlist * equivalentPatterns;
*/

	int arrayIndex;
};

#endif
